program icqx2002;
{$R *.res}
{$R maindlg3.res}

uses
  Windows, Messages, Crk_Utils, ShellApi, ShlObj,ActiveX;

const

  DLG_MAIN = 'MAINDLG';
  IDC_ED_PATH = 500;
  IDC_ED_COUNT = 520;
  IDC_ED_BEGIN = 530;
  IDC_BTN_PATH = 510;
  IDC_BTN_APPLY = 1001;
  IDC_BTN_ABOUT = 1002;
  IDC_BTN_EXIT = 1003;
  IDC_CBX_DESK = 2000;
  IDC_CBX_PROG = 2001;
  IDC_CBX_Safe = 2002;
  IDC_GP_PATH = 501;
  IDC_GP_COUNT = 521;
  IDC_GP_BEGIN = 531;
  IDC_GP_ACTION = 1000;

  Slash='\';

var
  AIcon, hMain: THandle;                               
  Path:string;
  iCount,iBegin:int;
  isDeskLink,isProgLink,isSafe:boolean;

procedure End_Work(AWnd: HWND);
begin
  EndDialog(AWnd, 0);
  Halt;
end;

procedure UpdateEnabled;
var
  s: string;
  b: boolean;
begin
  s := GetWndText(GetDlgItem(hMain, IDC_ED_PATH));
  b := FileExists(Pchar(s));
  b := b and (length(GetWndText(GetDlgItem(hMain, IDC_ED_COUNT))) > 0)
         and (length(GetWndText(GetDlgItem(hMain, IDC_ED_BEGIN))) > 0);
  EnableWindow(GetDlgItem(hMain, IDC_BTN_APPLY), b);
end;


procedure DlgToVars;
var
  b:LongBool;
begin
  Path:=GetWndText(GetDlgItem(hmain, IDC_ED_PATH));
  icount:=Abs(GetDlgItemInt(hMain,IDC_ED_COUNT,b,true));
  iBegin:=Abs(GetDlgItemInt(hMain,IDC_ED_BEGIN,b,true));
  isDeskLink:=IsDlgButtonChecked(hmain,IDC_CBX_DESK)=BST_CHECKED;
  isProgLink:=IsDlgButtonChecked(hmain,IDC_CBX_PROG)=BST_CHECKED;
  isSafe:=IsDlgButtonChecked(hmain,IDC_CBX_Safe)=BST_CHECKED;
end;

function ReplaceNum(s:string;i:int):string;
var
  exe:string;
  p:int;
const
  sDot='.';
begin
  exe:=s;
  repeat
    p:=Pos(sDot,exe);
    if p>0 then
      exe:=copy(exe,p+1,length(exe));
  until p=0;
  if length(exe)=Length(s) then
    exe:='';
  if length(exe)<>0 then
    exe:=sDot+exe;
  result:=copy(s,1,length(s)-length(exe));
  s:=IntToStr(i);
  i:=length(s);
  delete(result,length(result)-i+1,i);
  result:=result+s+exe;
end;

procedure CreateLink(FileName: string);
var
  IObject: IUnknown;
  SLink: IShellLink;
  PFile: IPersistFile;
  path:array [0..MAX_PATH-1] of WideChar;
  ws:WideString;

  function GetSpecFolderPath(wPath:PWideChar;nFolder:integer):boolean;
  var
    PIDL:PItemIDList;
  begin
    result:=(SHGetSpecialFolderLocation(hMain,nFolder,pidl)=NOERROR ) and
      SHGetPathFromIDListW(Pidl,wPAth);
  end;

begin

  CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER or
    CLSCTX_LOCAL_SERVER, IUnknown, IObject);
  SLink := IObject as IShellLink;
  PFile := IObject as IPersistFile;
  with SLink do begin
    SetDescription('ICQ clone created by ICQX');
    SetWorkingDirectory(Pchar(ExtractFilePath(FileName)));
    SetPath(PChar(FileName));
    SetIconLocation(pchar(FileName),0);
  end;
  Filename:=ExtractFileName(Filename);
  Filename:=Slash+changefileext(FileName,'.lnk');
  ws:=FileName;
  if isDeskLink then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_DESKTOP,false);
    if GetSpecFolderPath(@path[0],CSIDL_DESKTOP) then
      PFile.Save(pWideChar(Path+ws), FALSE);
  end;
  if isProgLink then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_PROGRAMS,false);
    if GetSpecFolderPath(@path[0],CSIDL_PROGRAMS) then
      PFile.Save(pWideChar(path+'\ICQ'+ws), FALSE);
  end;
end;

procedure ReplaceSpaceBySub(var AStr:pchar);
var
  p:pchar;
begin
  p:=Astr;
  while p^<>#0 do
  begin
    if p^=' ' then p^:='_';
    inc(p);
  end;
end;


procedure Apply;
type
  TSRec = record
    Text:Pchar;
    fileName:pchar;
    dwLoc:dword;
    optional:boolean;
  end;
var
  i,j:int;
  s,r:string;
const
  sGlobal='Global\';
  sMutex='Mirabilis ICQ Mutex';
  sNewGlobal='Mirabilis_ICQ_Global_Mutex';
  sLocal='Local\Mirabilis_ICQ_Local_Mutex';

  sOwner='LastOwner';
  sB='Can''t find string "';
  sin='" in ';
  sDll='ICQWUtl.dll';
  sIcq='icq.exe';

  ar:array[0..5] of TSrec = (
        (text:sMutex; filename:sDll),
        (text:sGlobal+sMutex; filename:sDll),
        (text:sDll; filename:sIcq),
        (text:sOwner; filename:sIcq),
        (text:sLocal; filename:sDll; optional:true),
        (text:sGlobal+sNewGlobal; filename:sDll; optional:true)
  );
begin
  DlgToVars;
  if not FileExists(Pchar(path)) then exit;

  path:=ExtractFilePath(path);


  for i:=1 to High(ar) do
  begin
    ar[i].dwLoc:=FindDataInFile(Path+ar[i].fileName,ar[i].Text,Length(ar[i].text));
    if ar[i].dwLoc=0 then
      if ar[i].optional then
        ar[i].dwLoc:=0
      else
      if IsSafe then
      begin
        ShowMessage(hMain,sB+ar[i].Text+sin+ar[i].fileName);
        exit;
      end;
  end;

  ar[0].dwLoc:=FindDataInFile(path+ar[0].fileName,ar[0].Text,Length(ar[0].text),true,ar[1].dwLoc+DWORD(length(ar[1].text)));
  if ar[0].dwLoc=0 then
    if ar[0].optional then
      ar[0].dwLoc:=0
    else
    begin
      ShowMessage(hMain,sB+ar[0].Text+sin+ar[0].fileName);
      exit;
    end;

  try
    for i:=0 to iCount-1 do
    begin
      for j:=0 to High(ar) do
        if ar[j].dwLoc<>0 then
        begin

          s:=ReplaceNum(ar[j].fileName,i+iBegin);
          if not FileExists(Pchar(Path+s)) then
            if not CopyFile(Pchar(Path+ar[j].fileName),pchar(path+s),false) then
            begin
              ShowMessage(hMain,'Can''t copy'+ ar[j].fileName+' to '+s);
              exit;
            end;
          r:=ReplaceNum(ar[j].Text,i+iBegin);
          WriteDataToFile(Path+S,ar[j].dwLoc,Pchar(r),length(r));
        end;
      CreateLink(Path+ReplaceNum(sIcq,i+iBegin));
    end;
  finally
  end;  
  ShowMessage(hMain,'All copy created.');
end;

function FindICQPath:string;
const
  ICQRegRoot='Software\Mirabilis\ICQ\DefaultPrefs';
  Slash='\';
begin
  result:=RegGetStringEx(HKEY_LOCAL_MACHINE,ICQRegRoot,'ICQPath','');
  if result='' then exit;
  if result[length(result)]<>Slash then result:=result+Slash;
  result:=result+'icq.exe';
  SetDlgItemText(hMain,IDC_ED_PATH,Pchar(result));
end;

function DlgProc(hWin, uMsg, wParam, lParam: Integer): Integer; stdcall;
var
  s: string;
begin
  Result := 0;
  case uMsg of
    WM_COMMAND: case LOWORD(wParam) of
        IDC_BTN_EXIT: End_Work(HWin);
        IDC_ED_PATH,
        IDC_ED_COUNT,
        IDC_ED_BEGIN: if HIWORD(wParam) = EN_CHANGE then
            UpdateEnabled;
        IDC_BTN_PATH: if HIWORD(wParam) = BN_CLICKED then
          begin
            s := 'icq.exe';
            if SelectExeFile(s) then
              SetDlgItemText(hWin, IDC_ED_PATH, Pchar(s));
          end;
        IDC_BTN_ABOUT: if HIWORD(wParam) = BN_CLICKED then
            ShellAbout(hMain, 'ICQX v1.3 for ICQ 2002a',
              'Copyright  Tir Na Nog'#13#10'http://tirna.narod.ru', AIcon);
        IDC_BTN_APPLY: if HIWORD(wParam) = BN_CLICKED then
            Apply;
      end;
    WM_INITDIALOG:
      begin
        hMAin := hWin;
        AIcon := LoadIcon(hInstance, 'MAINICON');
        SendMessage(hWin, WM_SETICON, ICON_SMALL, AIcon);
        SendMessage(hWin, WM_SETICON, ICON_BIG, AIcon);
        FindICQPath;
        SetDlgItemInt(hMain, IDC_ED_COUNT, 1,false);
        SetDlgItemInt(hMain, IDC_ED_BEGIN, 1,false);
        CheckDlgButton(hWin, IDC_CBX_DESK, BST_CHECKED);
        CheckDlgButton(hWin, IDC_CBX_PROG, BST_CHECKED);
        CheckDlgButton(hWin, IDC_CBX_Safe, BST_CHECKED);
      end;
    WM_DESTROY,
      WM_CLOSE: End_Work(hWin);
  end;
end;


begin
  CoInitialize(nil);
  try
    DialogBoxParam(HINSTANCE, PChar(DLG_MAIN), 0, @DlgProc, 0)
  finally
    CoUninitialize;
  end;
end.
